

char uart_rd = 0;
int i,j,k=2;

void main() {
    TRISB = 0x00;
    TRISA = 0xFF;
    TRISC = 0x80;
    TRISD = 0x00;
    PORTA = 0x00;
    PORTC = 0x00;
    PORTD = 0x00;

    UART1_Init(9600);
    Delay_ms(100);

   do
        {
          if(UART1_Data_Ready() == 1)   //checking for a start command
              {
                uart_rd = UART1_Read();



                if(uart_rd == 83)PORTD.F0=1;
                else PORTD.F0=0;

                uart_rd = '\0';
                }

          }while(PORTD.F0==0);  // start command obtained exit loop
           for(i=5;i>=0;i--)  //msb of counter
             {
               PORTB =i;
               for(j=9;j>0;j--) //Lsb of counter
                  {
                    PORTD =j;       //Lsb from port d
                    delay_ms(1000);
                  }
               PORTD =0;
               delay_ms(1000);
             }
         PWM1_Init(1000);       // setup motor circuit
         PWM1_start();
         PWM1_Set_Duty(160);
    do
    {
    if(PORTD.F0==0);  // if counter completed proceed
      {
          do
          {
             if (PORTD.F0==0) // counter complete check just for convinience
             {PORTB.F4 = 1; //Run motor in clockwise

              delay_ms(1000);
              PORTB.F4 = 0; // stop motor
              TRISB.F6 = 1;  // 6th pin as input for sensor
              if(PORTB.F6==0) continue; // if no object  goes to last of this brace
              else if(PORTB.F6==1) // if object open gate
                {
                  PORTB.F5 = 1; //Run motor in anti-clockwise
                  delay_ms(1000);
                  PORTB.F5 = 0;   //stop motor
                  delay_ms(2000);
                 }
              }
           }while(PORTB.F6==1); // loops this until object is cleared , F6=0
            PORTD.F6=1;   // indication that everything clear
            UART1_Init(9600); // send back pass command
            delay_ms(100);  // stabilise uart
            while(k>0) {         // k is initialized as 2 so send 2 P
                UART1_Write(80);  // send P
                Delay_ms(2000);
                k--;
              }
        }
    } while(PORTD.F0==1);
}